<template>
	<view class="uni-page-modal-3200">
		<view class="v-content">
			<!-- 表头样式 -->
			<OIForm ref="refBaseForm" class="v-headStyle" :form="head_styledef.form" @on-focus="ontap"
				@on-change="onEnterChange" @on-click-prefix="onEnterChange" @on-click-suffix="onEnterChange"></OIForm>
			<view class="v-scroll-view">
				<scroll-view :scroll-top="scrollTop" :scroll-y="true" class="scroll-y" @scrolltolower="scrolltolower"
					@scroll="scroll">
					<view class="view-content" id="tabpanel">
						<view class="dv-panel dv-panel-bkcolor" v-for="(style,ii) in detail1StyleDefList" :key="ii"
							@click="onPanelClick(ii)" :id="'panel'+style.form.htmlobjId"
							:class="activeItem == style?'bk-active':''">
							<div class="dv-panel-button" v-if="param.ListPage.CheckBox==true">
								<checkbox-group>
									<label>
										<checkbox :value="style.SelBut_Checked" :checked="style.SelBut_Checked" />
									</label>
								</checkbox-group>
							</div>
							<!-- HTML页面类型显示 -->
							<div class="dv-listHtml-Panel" v-if="ListHtml_Panel" v-html="ListHtml_Panel[ii]"
								:style="param.ListPage.CheckBox==true && param.ListPage.Click_View==true?'width:85%;': param.ListPage.CheckBox==false && param.ListPage.Click_View==true?'width:91%;':param.ListPage.CheckBox==true && param.ListPage.Click_View==false?'width:88%;':'width:100%;'">

							</div>
							<div class="dv-panel-input" v-if="!ListHtml_Panel"
								:style="param.ListPage.CheckBox==true && param.ListPage.Click_View==true?'width:85%;':param.ListPage.CheckBox==false && param.ListPage.Click_View==true?'width:91%;':param.ListPage.CheckBox==true && param.ListPage.Click_View==false?'width:88%;':'width:100%;'">
								<OIForm class="v-area dv-panel" :form="style.form.items" viewMode></OIForm>

							</div>
							<div class="dv-panel-button" v-if="param.ListPage.Click_View==true">
								<a @click="onViewPageClick(style)"><i class="mobox-normal-right-arrow" /></a>
							</div>
							<div class="dv-panel-buticon" v-if="param.ListPage.ListItem_Button">
								<view class="btn-padding" v-for="(btn,key) in param.ListPage.ListItem_Button">
									<a @click="onBtnClick(btn,style)" :title="btn.ShowName" v-if="btn.Style=='img'">
										<i :class="btn.Img" />
									</a>
									<button type="default" @click="onBtnClick(btn,style)" class="btn-padding"
										v-else-if="btn.Style=='text'">{{btn.ShowName}}</button>
								</view>
							</div>
						</view>
					</view>
				</scroll-view>
			</view>
		</view>

		<view class="view-floor">
			<button type="default" @click="cancel" class="btn_cancel"
				:style="{'width':param.ListPage.Page_Button.length>0?'39.5%':'48.5%'}">{{translateSys("close")}}</button>
			<button type="default" @click="Refresh" class="btn_refresh" :class="refreshing?'btn_disabled':''"
				:disabled="refreshing"
				:style="{'width':param.ListPage.Page_Button.length>0?'39.5%':'48.5%'}">{{translateSys("refresh")}}</button>
			<view class="uni-padding-wrap" v-if="param.ListPage.Page_Button.length>0">
				<view class="uni-btn-v">
					<a @tap="actionSheetTap">
						<text class="mobox-normal-more" />
					</a>
				</view>
			</view>
		</view>
	</view>
</template>

<script>
	import {
		Base64
	} from '@/js/Base64.js';
	import classUtils from "@/js/utils.js"
	import {
		appGetInfo,
		dictGetInfo
	} from "@/api/mobox.js"
	import {
		getUIStyleInfo,
		runCustomEvent,
		dataObjQuery,
		dataObjDel
	} from "@/api/data.js"
	import dayjs from "dayjs";
	import OIForm from '@/components/oi-form/index.vue'
	import buttonClickMixin from '@/mixins/button-click.js';

	export default {
		mixins: [buttonClickMixin],
		components: {
			OIForm
		},
		onNavigationBarButtonTap(e) {
			//  	console.log(e);
			// e.text="\ue924";
			// console.log(e.fontSize);
			if (this.isFilter)
				this.isFilter = false;
			else
				this.isFilter = true;
		},
		onBackPress(e) {
			// console.log("监听返回按钮事件",e);
			var eventChannel = this.$scope.eventChannel;
			// const eventChannel = this.getOpenerEventChannel();
			eventChannel.emit('view_3201', "");
			// uni.navigateBack({
			// 	delta:1 ,//返回层数，2则上上页
			// });
			// return true;
		},
		data() {
			return {
				title: this.translateSys('add2'),
				isFilter: true,
				param: {},
				focusMateria: false,
				styledef: {},
				head_styledef: {
					form: {
						items: []
					}
				},
				detail1_styledef: {},
				detail1StyleDefList: [],
				items: [],
				active_id: '',
				//activelist: [],
				activeItem: {},
				where: '',
				wheres: '',
				orderby: '',
				query_id: '',
				pageindex: 1,
				page_size: 10,
				page_count: 0,
				scrollTop: 0,
				old: {
					scrollTop: 0
				},
				isScroll: true,
				//获取数据类的HTML页面
				ListHtml_Panel: "",
				ListPageHtml_Show: {
					name: "",
					event: {
						id: "",
						name: ""
					}
				},
				refreshing: false
			};
		},
		async onLoad(options) {
			// console.log(options);
			uni.setNavigationBarTitle({
				title: options.titlename
			}); //设置顶部标题 
			this.title = options.titlename;
			this.param = JSON.parse(options.param);


			this.styledef = {};
			this.head_styledef = {
				form: {
					items: []
				}
			};
			this.detail1_styledef = {};
			this.detail1StyleDefList = [];
			this.ListHtml_Panel = "";
			this.ListPageHtml_Show = {
				name: "",
				event: {
					id: "",
					name: ""
				}
			};
			this.items = [];
			this.active_id = '';
			this.activeItem = {};
			//this.activelist = [];

			if (this.param.ListPage.ListItem_UIDef?.ui_type == "HTML页面") {
				// HTML页面
				//获取数据类的HTML页面
				await this.Html_UIstyleGetInfo(this.param.DataCls.id, this.param.ListPage.ListItem_UIDef.id, options
					.paramValue);
			} else {
				await this.Detail1_UIstyleGetInfo(this.param.DataCls.id, this.param.ListPage.ListItem_UIDef.id);

				await this.initial(options.paramValue);
			}
			// this.isFilter=true;
			// if(this.param.ShowFilter)
			//   this.isFilter=false;
			// //获取数据类的自定义表单参数
			// if(this.param.Query_Panel){
			// 	this.Head_UIStyleGetInfo(this.param.DataCls.id,this.param.Query_Panel.id);
			// }
			// if(this.param.ListPage.ListItem_UIDef?.ui_type=="HTML页面"){
			// 	// HTML页面
			// 	//获取数据类的HTML页面
			// 	await this.Html_UIstyleGetInfo(this.param.DataCls.id,this.param.ListPage.ListItem_UIDef.id);
			// }else{
			// 	await this.Detail1_UIstyleGetInfo(this.param.DataCls.id,this.param.ListPage.ListItem_UIDef.id);
			// }
			// this.orderby = this.param.Order?this.param.Order:'T_CREATE Desc';
			// if(this.param.Query_Event){
			//     await this.onSearChange(this.param.DataCls.id,this.param.Query_Event.id);
			// } else{
			//   this.wheres = this.param.Condition;
			//   this.pageindex = 1;
			//   this.page_size = 3;
			//   this.query_id = "";
			//   await this.loadDataGetList();
			// }
			// console.log(this.param);
			//页面初始化获取焦点
			// this.focusMateria=true; 
		},
		methods: {
			//
			setData: function(obj) {
				let that = this;
				let keys = [];
				let val, data;

				Object.keys(obj).forEach(function(key) {
					keys = key.split(".");
					val = obj[key];
					data = that.$data;
					keys.forEach(function(key2, index) {
						if (index + 1 == keys.length) {
							that.$set(data, key2, val);
						} else {
							if (!data[key2]) {
								that.$set(data, key2, {});
							}
						}
						data = data[key2];
					});
				});
			},

			//初始化
			async initial(paramValue) {
				this.refreshing = true
				this.isFilter = true;
				if (this.param.ShowFilter)
					this.isFilter = false;
				//获取数据类的自定义表单参数
				if (this.param.Query_Panel) {
					await this.Head_UIStyleGetInfo(this.param.DataCls.id, this.param.Query_Panel.id);
					//传入参数值
					if (paramValue) {
						const attrs = paramValue.attrs || [];
						(this.head_styledef?.form?.items || []).forEach(async (ele, index) => {
							if (ele.name != "Layout") {
								attrs.forEach(async (ele2, index2) => {
									if (ele.fieldId == ele2.name) {
										ele.value = ele2.value;
									}
								});
							} else {
								ele.setting.colList.forEach(async (col) => {
									if (col) {
										attrs.forEach(async (ele2,
											index2) => {
											if (col.fieldId == ele2.name) {
												col.value = ele2.value;
											}
										});
									}
								});
							}
						})
					}
				}
				this.orderby = this.param.Order ? this.param.Order : 'T_CREATE Desc';
				if (this.param.Query_Event) {
					await this.onSearChange(this.param.DataCls.id, this.param.Query_Event.id);
				} else {
					this.wheres = this.param.Condition;
					this.pageindex = 1;
					this.page_size = 3;
					this.query_id = "";
					this.detail1StyleDefList = [];
					await this.loadDataGetList();
				}
				this.refreshing = false

			},
			//滚动到底部后懒加载数据
			async scrolltolower(e) {
				// console.log(e)
				if (this.isScroll) { //判断刷新一次后不会持续刷新
					if (this.page_count == this.pageindex) {
						return;
					}
					this.pageindex += 1;
					if (this.where || this.page_count == 1) {
						this.query_id = "";
						this.detail1StyleDefList = [];
					}
					await this.loadDataGetList();
				}
			},
			scroll: function(e) {
				// console.log(e.detail.scrollTop)
				this.old.scrollTop = e.detail.scrollTop
			},
			async Head_UIStyleGetInfo(class_id, style_id) { //获取自定义表单样式
				try {
					var $this = this;
					var dataInfo = {
						class_id: class_id,
						ui_style_id: style_id,
					};
					// console.log(dataInfo);
					const result = await getUIStyleInfo(dataInfo)
					var styledef = "";
					if (result.style_def) {
						//mobox2的style_def是json字符串
						styledef = result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!result.style_def.includes('"')) styledef = Base64.decode(result
							.style_def);
					}
					$this.head_styledef = result.style_def ? JSON.parse(styledef) : {};
					// this.form = this.head_styledef.form.model;
					// console.log($this.head_styledef);
					if ($this.head_styledef.form?.items) {
						$this.head_styledef.form.items.forEach(async (ele, index) => {
							console.log(ele.useDict);
							if (ele.useDict == true) { //判断useDict是否使用字典
								await this.DictGetInfo(ele.bind.dict, index, 'mast');
							} else {
								if (ele?.name === "Select") {
									const selections = ele?.selections || []
									//有默认值，显示默认值
									let itemName = ele.value || "";
									if (itemName) {
										$this.head_styledef.form
											.model[ele.fieldId] = itemName;
									}
									$this.head_styledef.form.items[index].selections = selections.map((
										a) => {
										return {
											value: a.value,
											text: a.label
										}
									})
								}

							}

						});
						const app = getApp()
						if (app.globalData.bindClasses) {
							$this.head_styledef.form.items.push({
								name: "Input",
								label: this.translate("classes"),
								labelWidth: 100,
								disabled: true,
								value: app.globalData.classes,
								setting: {
									width: 100,
									height: 50,
								},
								bind: {
									attr: "",
								},
								fieldId: "S_CLASSES",
							})
							$this.head_styledef.form.model["S_CLASSES"] = app.globalData.classes
						}

					}
				} catch (ex) {
					// console.log(ex);
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : ex
					uni.showModal({
						title: this.translateSys("error") + "1.1",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}

			},
			async Detail1_UIstyleGetInfo(class_id, style_id) { //获取自定义表单样式
				try {
					var $this = this;
					var dataInfo = {
						class_id: class_id,
						ui_style_id: style_id,
					};
					// console.log(dataInfo);
					const result = await getUIStyleInfo(dataInfo)
					var styledef = "";
					if (result.style_def) {
						//mobox2的style_def是json字符串
						styledef = result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!result.style_def.includes('"')) styledef = Base64.decode(result
							.style_def);
					}
					$this.detail1_styledef = result.style_def ? JSON.parse(styledef) : {};
					$this.detail1_styledef.SelBut_Checked = false;
				} catch (ex) {
					// console.log(ex);
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : ex
					uni.showModal({
						title: this.translateSys("error") + "1.1",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}


			},
			async Html_UIstyleGetInfo(class_id, style_id, paramValue) { //获取自定义表单样式
				try {
					var $this = this;
					var dataInfo = {
						class_id: class_id,
						ui_style_id: style_id,
					};
					// console.log(dataInfo);
					const result = await getUIStyleInfo(dataInfo)
					var styledef = "";
					if (result.style_def) {
						//mobox2的style_def是json字符串
						styledef = result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!result.style_def.includes('"')) styledef = Base64.decode(result
							.style_def);
					}
					// console.log(styledef);
					$this.ListPageHtml_Show = result.style_def ? JSON.parse(styledef) : {};
					// console.log($this.ListPageHtml_Show);

					$this.initial(paramValue);
				} catch (ex) {
					// console.log(ex);
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : ex
					uni.showModal({
						title: this.translateSys("error") + "1.1",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}
			},
			async DictGetInfo(dict, index, type) { //Mobox3得到得到字典信息字典项列表
				this.data = [];
				var $this = this;
				var dataInfo = {
					dict_id: dict.id,
					dict_name: dict.name
				};
				try {
					const result = await dictGetInfo(dataInfo)
					if (type == 'mast') {
						var list = [];
						var itemName = '';
						(result.dict_item_list || []).forEach((item) => {
							if (item.is_default == '1')
								itemName = item.name
							list.push({
								text: item.value ? item.value : item.name,
								value: item.name,
							});
						});
						//有默认值，显示默认值
						if (itemName) {
							$this.head_styledef.form.items[index].value = itemName;
							var attr = $this.head_styledef.form.items[index].fieldId;
							$this.head_styledef.form.model[attr] = itemName;
						}
						$this.head_styledef.form.items[index].dict = list;
						var head_styledef = JSON.parse(JSON.stringify($this.head_styledef));
						$this.head_styledef = [];
						$this.head_styledef = head_styledef;
					}
				} catch (ex) {
					// console.log(ex);
					uni.showModal({
						title: this.translateSys("error") + "3",
						content: ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}
			},

			// 执行查询事件
			async onSearChange(clsid, eventid) {
				try {
					if (eventid) {
						var $this = this;
						var dataInfo = {
							ed_type: 0,
							start_transaction: true,
							class_id: clsid,
							event_id: eventid,
						};
						var result = await runCustomEvent(dataInfo)
						// console.log(result);

						if (result.ret != 0) {
							var tip = result.err_info ? typeof result.err_info == 'string' ? result
								.err_info : result.err_info.join('<br/>') : '';
							if (result.ret == 801) {
								if (this.param.Only_Script_Error) {
									let pos = tip.indexOf("：");
									if (pos > -1) tip = tip.substring(pos + 1);
								}
								uni.showModal({
									title: this.translateSys("tip"),
									content: tip,
									showCancel: false,
									confirmText: this.translateSys('close')
								});
							} else uni.showModal({
								title: this.translateSys("tip"),
								content: tip + ',' + this.translateSys('tip') + ':' + result
									.ret,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
							return false;
						} else {
							var tip = result.info ? typeof result.info == 'string' ? result.info :
								result.info.join('<br/>') : '';
							if (tip) uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});

							if (result.result_type == 0 && result.action) {
								result.action.forEach(item => {
									if (item.action_type == "set_query_condition") {
										var value = item.value;
										$this.wheres = value.condition;
										$this.orderby = value.order ? value.order : $this
											.orderby;
										$this.pageindex = 1;
										$this.query_id = "";
										$this.detail1StyleDefList = [];
										$this.loadDataGetList();
									}

								});
							} else {
								if (result.info) {
									uni.showModal({
										title: this.translateSys("tip"),
										content: result.info,
										showCancel: false,
										confirmText: this.translateSys('close')
									});
								}
							}
						}
					}
				} catch (ex) {
					var tip = typeof ex == "string" ? ex : ex.message;
					uni.showModal({
						title: this.translateSys("error") + "4.2",
						content: this.translate("execute_query_event_failed") + this.translateSys(
								"comma") +
							tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});

				}
			},
			//查询数据类数据信息
			async loadDataGetList() {
				try {
					uni.showLoading({
						title: this.translateSys("loading"),
						mask: true
					});
					//条件查询
					var condition = this.wheres;
					if (this.where) {
						if (condition) condition += ' and ';
						condition += this.where;
					}
					// console.log(condition);
					// console.log(this.orderby);
					var $this = this;
					var dataInfo = {
						class_id: this.param.DataCls.id,
						attrs: [],
						condition: this.toWhereBase64String("" + condition + ""),
						prj_rel_type: "",
						order_by: this.orderby,
						page_size: this.page_size,
						page: this.pageindex,
						query_id: this.query_id,
					};
					dataObjQuery(dataInfo).then(result => {
						console.log(result);
						uni.hideLoading();

						// var list=[];
						$this.query_id = '';
						if (result) {
							$this.page_count = result.page_count;
							if (result.page_count > 1) $this.query_id = result.query_id;
							// console.log($this.ListPageHtml_Show.event);
							if ($this.ListPageHtml_Show.event.id) {
								const detail1StyleDefList = $this.detail1StyleDefList
								result.obj_list.forEach((obj) => {
									var info = {
										id: obj.id,
									};
									obj.attr_list.forEach((attr) => {
										info[attr.name] = attr.value;
									});
									var detailStyle = {
										SelBut_Checked: false,
										form: {},
										info: info
									};
									detailStyle.form.htmlobjId = obj.id ? obj.id.replace(
											/-/g, '')
										.replace('{', '').replace('}', '') : 'null';
									detailStyle.form.objId = obj.id;
									detailStyle.form.attrs = obj.attr_list;
									detail1StyleDefList.push(detailStyle);
									// $this.activelist.push({
									// 	active: false
									// });
								});
								// console.log(this.detail1StyleDefList);

								$this.setData({
									detail1StyleDefList: detail1StyleDefList
								})

								var jsonlist = [];
								$this.detail1StyleDefList.forEach(attr => {
									jsonlist.push({
										id: attr.info.id,
										attrs: Object.keys(attr.info).map((a) => ({
											attr: a,
											value: attr.info[a] || "",
										}))
									});
								});
								// console.log(jsonlist);
								var data_json = Base64.encode(JSON.stringify(jsonlist));
								var eventid = $this.ListPageHtml_Show.event.id;
								if (!$this.ListPageHtml_Show.event.id.includes('{'))
									eventid = '{' + $this.ListPageHtml_Show.event.id + '}';
								//HTML页面事件
								$this.runCustomEvent({
									ed_type: 0,
									start_transaction: true,
									class_id: $this.param.DataCls.id,
									event_id: eventid,
									data_json,
								});
							} else {
								// $this.detail1StyleDefList=[];
								const detail1StyleDefList = []
								result.obj_list.forEach((obj) => {
									var styleStr = JSON.stringify($this.detail1_styledef);
									var detailStyle = JSON.parse(styleStr);
									// var info ={
									//     S_ID:obj.id,
									// };
									obj.attr_list.forEach((attr) => {
										// info[attr.name]=attr.value;
										detailStyle.form.items.forEach(ele => {
											if (ele.name != 'Layout') {
												if (ele.fieldId == attr
													.name) ele
													.value = attr.value;
											} else if (ele.name ==
												'Layout') {
												ele.setting.colList
													.forEach(
														col => {
															if (col) {
																if (col
																	.fieldId ==
																	attr
																	.name)
																	col
																	.value =
																	attr
																	.value;
															}
														});
											}
										});
									});

									detailStyle.form.htmlobjId = obj.id ? obj.id.replace(
											/-/g, '')
										.replace('{', '').replace('}', '') : 'null';
									detailStyle.form.objId = obj.id;
									detailStyle.form.attrs = obj.attr_list;
									detail1StyleDefList.push(detailStyle);
									// $this.activelist.push({
									// 	active: false
									// });
									//list.push(info);
								});
								$this.setData({
									detail1StyleDefList: detail1StyleDefList
								})
							}

							// 解决view层不同步的问题
							// $this.scrollTop = $this.old.scrollTop;
							$this.isScroll = false;
							setTimeout(function() {
								$this.isScroll = true;
							}, 1000);
							// console.log($this.detail1StyleDefList);
						}




					}).catch(ex => {
						// console.log(ex);
						uni.showModal({
							title: this.translateSys("error") + "5.1",
							content: ex.errMsg,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
					});
				} catch (ex) {
					var tip = typeof ex == "string" ? ex : ex.message;
					uni.showModal({
						title: this.translateSys("error") + "5.2",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}
			},

			//刷新
			Refresh(value) {
				//刷新当前页面
				this.initial();
				// uni.redirectTo({
				// 	url:'../modal/3200?param='+JSON.stringify(this.param)+"&titlename="+this.title,
				// });
			},
			//点击显示浏览对象显示页面
			async onViewPageClick(style) {
				if (this.param.ViewPage) {
					if (this.param.ViewPage.View_UIDef) {
						this.styledef = style;
						var $this = this;
						uni.navigateTo({
							url: '../modal/3200_view?param=' + JSON.stringify(this.param) +
								"&titlename=" +
								this.title + "&style=" + JSON.stringify(style),
							events: {
								// 为指定事件添加一个监听器，获取被打开页面传送到当前页面的数据
								ExitViewEvent: function(data) {
									console.log(data);
									//退出页面后事件
									var eventid = $this.param.ViewPage.Exit_View_Event?.id;
									if (eventid) {
										try {
											var obj_attr = {
												'S_ID': $this.styledef.form.objId
											};
											$this.styledef.form.attrs.forEach((attr) => {
												obj_attr[attr.name] = attr.value;
											});
											// console.log(obj_attr);
											var input_param = Base64.encode(JSON.stringify(
												obj_attr));
											$this.runCustomEvent({
												ed_type: 0,
												start_transaction: true,
												class_id: $this.param.DataCls.id,
												event_id: eventid,
												data_obj_id: $this.styledef.form.objId,
												obj_attr,
												input_param,
											});
										} catch (ex) {
											var tip = typeof ex == "string" ? ex : ex.message;
											uni.showModal({
												title: this.translateSys("error"),
												content: tip,
												showCancel: false,
												confirmText: this.translateSys(
													'close')
											});
										}
									}
								}
							},
						});
					}
				}
			},
			//点击按钮
			onBtnClick(btn, style) {
				var that = this
				if (btn.Prompt) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: btn.PromptContent || this.translate("are_you_sure"),
						cancelText: this.translateSys('ok'),
						confirmText: this.translateSys('cancel'),
						success: function(res) {
							if (res.cancel) {
								that.onButtonClicked(btn, style);
								// } else if (res.cancel) {
								// 	console.log('用户点击取消');
							}
						}
					});
				} else {
					this.handleButtonClick((done) => {
						that.onButtonClicked(btn, style);
						setTimeout(() => {
							done(); // 重置状态
						}, 1000);
					});
				}
			},
			//点击按钮列表
			actionSheetTap() {
				var that = this
				var itemlist = [];
				this.param.ListPage.Page_Button.forEach((btn) => {
					itemlist.push(btn.ShowName);
				});
				uni.showActionSheet({
					// title: '按钮列表',
					itemList: itemlist,
					success: (e) => {
						console.log(e.tapIndex);
						var btn = that.param.ListPage.Page_Button[e.tapIndex];
						if (btn.Prompt) {
							uni.showModal({
								title: this.translateSys("tip"),
								content: btn.PromptContent || this.translate("are_you_sure"),
								cancelText: this.translateSys('ok'),
								confirmText: this.translateSys('cancel'),
								success: function(res) {
									if (res.cancel) {
										that.onButtonClicked(btn);
										// } else if (res.cancel) {
										// 	console.log('用户点击取消');
									}
								}
							});
						} else that.onButtonClicked(btn);
					}
				})
			},
			//处理相关按钮
			async onButtonClicked(btn, style) {
				style = style || '';
				try {
					var enviroment = {
						button: "top",
						button_name: btn.ShowName,
						cls_id: btn.Cls_ID,
						function: "3200",
						master: {},
					};
					if (btn.FunCode == "Add" || btn.FunCode == "Modify") {
						if (btn.Edit_dlg.Model == "small") {
							this.showAddSmallDialog(btn, style, enviroment);
						} else {
							uni.showModal({
								title: this.translateSys("tip"),
								content: this.translateSys("unrealized"),
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						}
					} else if (btn.FunCode == "Delete") {
						this.DeleteObj(btn, style, enviroment);
						// } else if (btn.FunCode == "TriggerEvent") {
						//   this.triggerEvent(btn, style, enviroment);
					} else if (btn.FunCode == "TriggerEvent") {
						this.TriggerEvent(btn, style, enviroment);
						// } else if (btn.FunCode == "TriggerEvent") {
						//   this.triggerEvent(btn, style, enviroment);
					} else if (btn.FunCode == "RelatedFunction") {
						this.RelatedFunction(btn, style, enviroment);
						// } else if (btn.FunCode == "TriggerEvent") {
						//   this.triggerEvent(btn, style, enviroment);
					} else {
						uni.showModal({
							title: this.translateSys("tip"),
							content: this.translateSys("unrealized"),
							showCancel: false,
							confirmText: this.translateSys('close')
						});
					}
				} catch (ex) {
					var tip = typeof ex == "string" ? ex : ex.message;
					uni.showModal({
						title: this.translateSys("error"),
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}
			},
			//新增修改小窗口数据
			showAddSmallDialog(btn, style, enviroment) {
				var data = {
					Add_BtnName: btn.ShowName,
					EditDlgMode: btn.Edit_dlg.Model,
					clsid: this.param.DataCls.id,
					cls_name: this.param.DataCls.name,
					Edit_dlg: btn.Edit_dlg
				};
				var $this = this;
				uni.navigateTo({
					url: '../modal/3018?param=' + JSON.stringify(data) + "&titlename=" + btn
						.Edit_dlg.Name +
						"&type=addDataObj",
					events: {
						// 为指定事件添加一个监听器，获取被打开页面传送到当前页面的数据
						addDataObj: function(data) {
							console.log(data);
							$this.Refresh();
						},
					}
				});
			},
			//删除数据对象
			DeleteObj(btn, style, enviroment) {
				// console.log(style);
				var $this = this;
				uni.showModal({
					title: this.translateSys("tip"),
					content: this.translate("confirm_delete_data"),
					cancelText: this.translateSys('ok'),
					confirmText: this.translateSys('cancel'),
					success: function(res) {
						if (res.cancel) {
							var objID = style.form.objId;
							if (!style.form.objId.includes('{')) objID = '{' + style.form
								.objId + '}';

							var dataInfo = {
								class_id: btn.Cls_ID,
								class_name: '',
								obj_id: objID
							};
							// console.log(dataInfo);

							dataObjDel(dataInfo).then(ret => {
								//执行后处理事件
								$this.AfterProcess_Event(btn.clsId, btm
									.AfterProcess_Event,
									enviroment);
								//清除当前列表数据
								$this.detail1StyleDefList.forEach((ele,
									index) => {
									if (ele.form.objId == objID) {
										$this.detail1StyleDefList
											.splice(index, 1);
									}
								});
								uni.showModal({
									title: this.translateSys("tip"),
									content: this.translate(
										"delete_success"),
									showCancel: false,
									confirmText: this.translateSys(
										'close')
								});
							}).catch(ex => {
								// console.log(ex);
								uni.showModal({
									title: this.translateSys("error") +
										"6",
									content: ex.errMsg,
									showCancel: false,
									confirmText: this.translateSys(
										'close')
								});
							});
						} else if (res.cancel) {

						}
					}
				});

			},
			//执行事件
			async TriggerEvent(btn, style, enviroment) { //执行触发事件
				try {
					let obj_attr = {
						S_ID: this.styledef.form.objId
					};
					style.form.attrs.forEach((attr) => {
						obj_attr[attr.name] = attr.value;
					});

					if (!this.ListPageHtml_Show.event.id) {
						//判断没有HTML页面事件
						this.head_styledef.form.items.forEach(async (ele, index) => {
							if (ele.name != "Layout") {
								if (!obj_attr[ele.fieldId]) {
									obj_attr[ele.fieldId] = ele.value;
								}
							} else if (ele.name == "Layout") {
								ele.setting.colList.forEach(async (col, key) => {
									if (col) {
										if (!obj_attr[col.fieldId]) {
											obj_attr[col.fieldId] = col
												.value;
										}
									}
								});
							}
						});
					}

					const dataInfo = {
						ed_type: 0,
						start_transaction: true,
						class_id: btn.clsId,
						event_id: btn.event.id,
						data_obj_id: this.styledef.form.objId,
						obj_attr: obj_attr,
					}
					var result = await runCustomEvent(dataInfo)
					if (result.ret != 0) {
						var tip = result.err_info ? typeof result.err_info ==
							'string' ?
							result
							.err_info : result.err_info.join('<br/>') : '';
						if (result.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') +
								':' +
								result
								.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						return false;
					} else {
						var tip = result.info ? typeof result.info == 'string' ?
							result
							.info :
							result.info.join('<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});

					}
				} catch (ex) {
					var tip = typeof ex == "string" ? ex : ex.message;
					uni.showModal({
						title: this.translateSys("error"),
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					this.showError(ex);
				}
			},
			//跳转
			async RelatedFunction(btn, style, enviroment) {

				try {
					const defCode = btn.Related_Function?.Def_Code
					var $this = this;
					if (
						defCode == "3018" ||
						defCode == "3037" ||
						defCode == "3200" ||
						defCode == "3201" ||
						defCode == "5600" ||
						defCode == "5601" ||
						defCode == "5602"
					) {

						let name = defCode
						if (defCode == "3018" || defCode == "3037")
							name = defCode + "_2"
						var json = {
							app_id: [btn.Related_Function.ID],
						};
						console.log("RelatedFunction2", json);
						const result = await appGetInfo(json)
						if ((result || []).length > 0) {
							var app = result[0];
							var param = "";
							var appName = app.list_name || app.name
								.Name;
							var paramStr = app.param
							if (paramStr) {
								//mobox2的param是json字符串
								param = paramStr.replace(/\\/g, "");
								//mobox3的param是base64字符串
								if (!paramStr.includes('"')) param = Base64.decode(
									paramStr);
							}
							if (!param) {
								uni.showModal({
									title: this.translateSys("tip"),
									content: this.translate(
										'tip_no_app_param'),
									showCancel: false,
									confirmText: this.translateSys(
										'close')
								});
								return;
							}

							uni.navigateTo({
								url: '../modal/' + name + '?param=' +
									param + "&titlename=" +
									appName +
									"&type=relatedFunction&paramValue=" +
									JSON.stringify(style
										.form),
								events: {
									relatedFunction: function(data) {
										console.log(data);
										$this.Refresh();
									},
								}
							});
						} else {
							uni.showModal({
								title: this.translateSys("error"),
								content: this.translate(
									"function_not_exist"),
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						}

					} else {
						uni.showModal({
							title: this.translateSys("error"),
							content: this.translate("cannot_related_function"),
							showCancel: false,
							confirmText: this.translateSys('close')
						});

					}
				} catch (ex) {
					console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: this.translateSys("error"),
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return undefined
				}
			},
			//执行后处理事件
			async AfterProcess_Event(clsId, afterProcess_Event, enviroment) {
				try {
					if (afterProcess_Event.ID) {
						//执行后处理事件
						await this.runCustomEvent({
							ed_type: 0,
							start_transaction: true,
							class_id: clsId,
							event_id: afterProcess_Event.ID,
						});
					}
				} catch (ex) {
					var tip = typeof ex == "string" ? ex : ex.message;
					uni.showModal({
						title: this.translateSys("error") + "7",
						content: tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}
			},

			ontap(item) { //扫码功能
				// var $ele = e;
				//console.log(e.target)
				getApp().onScan((result) => {
					console.log(result.decodedata);
					item.value = result.decodedata;
					uni.hideKeyboard();
					var $this = this;
					console.log(item);
					let newVal = item.value.trim()
					if (newVal) {
						item.oldvalue = newVal;

						var attr = item.fieldId;
						this.head_styledef.form.model[attr] = newVal;
						var onChangeEvent = item.bind.onChangeEvent; //内容变化后事件
						var onSuffixClickCallbackEvent = item.bind
							.onSuffixClickCallbackEvent; //后图标点击事件
						var onSuffixClickEvent = item.bind
							.onSuffixClickEvent; //后图标点击回调
						var isflag = false;

						if (onChangeEvent.id) { //内容变化后事件
							$this.onChange(onChangeEvent);
						} else {
							$this.where = item.fieldId + " like '%" + newVal + "%'";
							$this.query_id = '';
							$this.pageindex = 1;
							$this.detail1StyleDefList = [];
							$this.loadDataGetList();
						}
						$this.focusMateria = true; //初始化，第二个输入框focus属性
						// setTimeout(function(){
						// 	$this.focusMateria=true; //第二个输入框获取焦点
						setTimeout(function() {
							uni.hideKeyboard();
						}, 1000);
						// },500);
						// if(onSuffixClickCallbackEvent.id){   //后图标点击事件
						//   this.onSuffixClick(onSuffixClickCallbackEvent);
						// }
						// if(onSuffixClickEvent.id){   //后图标点击回调
						//   this.onSuffixClickCallback(onSuffixClickEvent);
						// }
					}
				})
			},

			onEnterChange(item) { //回车，点击按钮，取消节点事件
				// console.log(item);
				let newVal = item.value
				if (typeof item.value == "string") {
					newVal = item.value.trim()
					if (!newVal)
						return
				}
				if (item.oldvalue != newVal) {
					item.oldvalue = newVal;
					var attr = item.fieldId;
					this.head_styledef.form.model[attr] = newVal;
					var onChangeEvent = item.bind.onChangeEvent; //内容变化后事件
					var onSuffixClickCallbackEvent = item.bind
						.onSuffixClickCallbackEvent; //后图标点击事件
					var onSuffixClickEvent = item.bind.onSuffixClickEvent; //后图标点击回调
					var isflag = false;

					if (onChangeEvent.id) { //内容变化后事件
						this.onChange(onChangeEvent);
					} else {
						this.where = item.fieldId + " like '%" + item.value + "%'";
						this.query_id = '';
						this.pageindex = 1;
						this.detail1StyleDefList = [];
						this.loadDataGetList();
					}
					// if(onSuffixClickCallbackEvent.id){   //后图标点击事件
					//   this.onSuffixClick(onSuffixClickCallbackEvent);
					// }
					// if(onSuffixClickEvent.id){   //后图标点击回调
					//   this.onSuffixClickCallback(onSuffixClickEvent);
					// }
				}
			},
			// 内容变化后事件
			async onChange(event) {
				try {
					if (event.id) {
						var obj_attr = this.head_styledef.form.model;
						// console.log(obj_attr);
						var input_param = Base64.encode(
							JSON.stringify(
								Object.keys(obj_attr).map((a) => ({
									attr: a,
									value: obj_attr[a] || "",
								}))
							)
						);
						var $this = this;
						var dataInfo = {
							ed_type: 0,
							start_transaction: true,
							class_id: this.head_styledef.form.clsId,
							class_name: '',
							event_id: event.id,
							event_name: '',
							data_obj_id: '',
							obj_attr: obj_attr,
							prj_id: '',
							ref_cls_id: '',
							rel_obj_id: '',
							user_login: '',
							data_json: '',
							compose_info: '',
							ext_info: '',
							global_attr: '',
							input_param: input_param,
						};
						runCustomEvent(dataInfo).then(result => {
							// console.log(result);
							if (result.ret != 0) {
								var tip = result.err_info ? typeof result
									.err_info ==
									'string' ?
									result
									.err_info : result.err_info.join(
										'<br/>') : '';
								if (result.ret == 801) {
									if (this.param.Only_Script_Error) {
										let pos = tip.indexOf("：");
										if (pos > -1) tip = tip.substring(
											pos + 1);
									}
									uni.showModal({
										title: this.translateSys(
											"tip"),
										content: tip,
										showCancel: false,
										confirmText: this
											.translateSys('close')
									});
								} else uni.showModal({
									title: this.translateSys(
										"tip"),
									content: tip + ',' + this
										.translateSys('tip') +
										':' +
										result
										.ret,
									showCancel: false,
									confirmText: this.translateSys(
										'close')
								});
								return false;
							} else {
								var tip = result.info ? typeof result
									.info == 'string' ? result
									.info :
									result.info.join('<br/>') : '';
								if (tip) uni.showModal({
									title: this.translateSys(
										"tip"),
									content: tip,
									showCancel: false,
									confirmText: this.translateSys(
										'close')
								});

								if (result.result_type == 0 && result
									.action) {
									result.action.forEach(item => {
										if (item.action_type ==
											"set_dlg_attr") {
											// value = {"attr":"xxx", "value":"xxx"}
											var data = item.value;
											$this.$data
												.head_styledef.form
												.items
												.forEach(
													async (
														ele,
														index
													) => {
														data.forEach(
															async (ele2,
																index
															) => {
																if (ele
																	.fieldId ==
																	ele2
																	.attr
																) {
																	ele.value =
																		ele2
																		.value;
																}
															});
													});
										}
									});
								} else {
									if (result.info) {
										uni.showModal({
											title: this
												.translateSys(
													"tip"),
											content: result.info,
											showCancel: false,
											confirmText: this
												.translateSys(
													'close')
										});
									}
								}
							}


						}).catch(ex => {
							// console.log(ex);
							uni.showModal({
								title: this.translateSys("error") +
									"8.1",
								content: ex.errMsg,
								showCancel: false,
								confirmText: this.translateSys(
									'close')
							});
						});
					}
				} catch (ex) {
					var tip = typeof ex == "string" ? ex : ex.message;
					uni.showModal({
						title: this.translateSys("error") + "8.2",
						content: this.translate(
								'execute_after_change_event_failed') + this
							.translateSys(
								"comma") +
							this.translate('reason') + this.translateSys(
								"colon") + tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});

				}
			},
			onDetail1EnterChange() {},
			//点中表单
			onPanelClick(value) { //点击面板高亮显示
				// console.log(value);
				this.setData({
					activeItem: this.detail1StyleDefList[value]
				})
				// this.activelist.forEach(ele => {
				// 	ele.active = false;
				// });
				// this.activelist[value].active = true;
			},

			//事件处理
			async runCustomEvent(dataInfo) {
				try {
					var $this = this;
					runCustomEvent(dataInfo).then(result => {
						console.log(result);

						if (result.ret != 0) {
							var tip = result.err_info ? typeof result
								.err_info ==
								'string' ?
								result
								.err_info : result.err_info.join(
									'<br/>') : '';
							if (result.ret == 801) {
								if (this.param.Only_Script_Error) {
									let pos = tip.indexOf("：");
									if (pos > -1) tip = tip.substring(
										pos + 1);
								}
								uni.showModal({
									title: this.translateSys(
										"tip"),
									content: tip,
									showCancel: false,
									confirmText: this
										.translateSys('close')
								});
							} else uni.showModal({
								title: this.translateSys(
									"tip"),
								content: tip + ',' + this
									.translateSys('tip') +
									':' +
									result.ret,
								showCancel: false,
								confirmText: this.translateSys(
									'close')
							});
							return false;
						} else {
							var tip = result.info ? typeof result
								.info == 'string' ? result
								.info : result
								.info.join('<br/>') : '';
							if (tip) uni.showModal({
								title: this.translateSys(
									"tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys(
									'close')
							});

							if (result.result_type == 0 && result
								.action) {
								result.action.forEach(item => {
									if (item.action_type ==
										"goback_to_pre_page"
									) { //返回上一页
										var value = item.value;
										uni.navigateBack({
											delta: 1, //返回层数，2则上上页
										});
									} else if (item
										.action_type ==
										"hidden_button"
									) { //隐藏按钮
										var value = item.value;
										value.forEach(btn => {
											var index =
												$this
												.param
												.ListPage
												.Page_Button
												.findIndex(
													button =>
													button
													.ShowName ==
													btn
												)
											if (index >
												-1)
												$this
												.param
												.ListPage
												.Page_Button
												.splice(
													index,
													1)
										})
										// } else if(item.action_type == "refresh_cur_row"){ //
										// 	var value = item.value;
									} else if (item
										.action_type ==
										"set_panel_html"
									) { //显示Html页面
										// var value = item.value;
										$this.ListHtml_Panel =
											item.value;
										// $this.detail1StyleDefList.forEach((ele,index)=>{
										// 	ele.ListHtml_Panel = item.value[index];
										// });

									} else {
										uni.showModal({
											title: this
												.translateSys(
													"tip"
												),
											content: this
												.translateSys(
													"quotation_mark_left"
												) +
												item
												.action_type +
												this
												.translateSys(
													"quotation_mark_right"
												) +
												this
												.translate(
													"tip_action_unprocessed"
												),
											showCancel: false,
											confirmText: this
												.translateSys(
													'close'
												)
										});
									}
								});
							} else {
								if (result.info) {
									uni.showModal({
										title: this
											.translateSys(
												"tip"),
										content: result.info,
										showCancel: false,
										confirmText: this
											.translateSys(
												'close')
									});
								}
							}
						}


					}).catch(ex => {
						// console.log(ex);
						uni.showModal({
							title: this.translateSys("error") +
								"9.1",
							content: ex.errMsg,
							showCancel: false,
							confirmText: this.translateSys(
								'close')
						});
					});
				} catch (ex) {
					var tip = typeof ex == "string" ? ex : ex.message;
					uni.showModal({
						title: this.translateSys("error") + "9.2",
						content: this.translate('execute_event_failed') +
							this.translateSys(
								"comma") +
							this.translate('reason') + this.translateSys(
								"colon") + tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});

				}
			},

			cancel(e) { //取消
				// var eventChannel = this.$scope.eventChannel;
				// // const eventChannel = this.getOpenerEventChannel();
				// eventChannel.emit('view_3201',"");
				uni.navigateBack({
					delta: 1, //返回层数，2则上上页
				});
			},
			/**
			 * 只支持["column1='A' or column2='B'", "column3='C' and column4='D'", "column5='E'"]这种格式
			 * {
			 *     "model": 0 / 1,
			 *     "condition":
			 *     [
			 *         [
			 *             { },
			 *             { },
			 *             { }
			 *         ],
			 *         [
			 *             { }
			 *         ],
			 *         [
			 *             { }
			 *         ]
			 *     ]
			 * }
			 */

			toWhereBase64String(list) {
				if (typeof list == 'string') list = [list]
				var sql = []
				var seps = [' not in', ' in', '<>', '!=', '<=', '>=', '<', '=',
					'>', ' like'
				]
				list.forEach(ls => {
					var where = ls.trim()
					if (where.startsWith('(') && where.endsWith(')'))
						where = where.replace(
							/^\(/,
							'').replace(
							/\)$/, '')
					if (where.toLowerCase().includes(' and ')) {
						// 二级and放在第一级数组中
						where.split(/ and /i).forEach(li => {
							var l = li.trim()
							if (l.startsWith('(') && l.endsWith(
									')')) l = l.replace(
								/^\(/,
								'').replace(
								/\)$/, '')
							var sep = ''
							for (var i = 0; i < seps.length; i++) {
								if (l.toLowerCase().includes(seps[
										i])) {
									sep = seps[i]
									break
								}
							}
							if (sep) {
								var values = l.split(new RegExp(
									sep, 'i'))
								var field = values[0]?.trim()
									.replace(/^\[/, '')
									.replace(
										/\]$/, '')
								var value = ''
								var op = sep.trim()

								if ([' in', ' not in'].includes(
										sep) && values[1]
									?.toLowerCase().includes(
										'select ') && values[1]
									?.toLowerCase()
									.includes(
										' from ')) {
									value = l.replace(field, '')
										.replace(
											/^\s*(in|not in)\s*/i,
											'').trim()
									if (value.startsWith('(') &&
										value.endsWith(')'))
										value = value
										.replace(/^\(/, '')
										.replace(/\)$/, '').trim()
								} else {
									value = values[1]?.trim()
										.replace(/^\'/, '')
										.replace(
											/\'$/, '')

									if (['in', 'not in'].includes(
											op)) {
										value = value.replace(
											/^\(/, '').replace(
											/\)$/,
											'')
										value = value.split(',')
											.map(v => v.trim()
												.replace(
													/^\'/, '')
												.replace(/\'$/, '')
											)
									}
								}
								sql.push([{
									field,
									value,
									op
								}])
							}
						})
					} else if (where.toLowerCase().includes(' or ')) {
						// 二级or放在第二级同一组数组中
						var s = []
						where.split(/ or /i).forEach(li => {
							var l = li.trim()
							if (l.startsWith('(') && l.endsWith(
									')')) l = l.replace(
								/^\(/,
								'').replace(
								/\)$/, '')
							var sep = ''
							for (var i = 0; i < seps.length; i++) {
								if (l.toLowerCase().includes(seps[
										i])) {
									sep = seps[i]
									break
								}
							}
							if (sep) {
								var values = l.split(new RegExp(
									sep, 'i'))
								var field = values[0]?.trim()
									.replace(/^\[/, '')
									.replace(
										/\]$/, '')
								var value = ''
								var op = sep.trim()

								if ([' in', ' not in'].includes(
										sep) && values[1]
									?.toLowerCase().includes(
										'select ') && values[1]
									?.toLowerCase()
									.includes(
										' from ')) {
									value = l.replace(field, '')
										.replace(
											/^\s*(in|not in)\s*/i,
											'').trim()
									if (value.startsWith('(') &&
										value.endsWith(')'))
										value = value
										.replace(/^\(/, '')
										.replace(/\)$/, '').trim()
								} else {
									value = values[1]?.trim()
										.replace(/^\'/, '')
										.replace(
											/\'$/, '')

									if (['in', 'not in'].includes(
											op)) {
										value = value.replace(
											/^\(/, '').replace(
											/\)$/,
											'')
										value = value.split(',')
											.map(v => v.trim()
												.replace(
													/^\'/, '')
												.replace(/\'$/, '')
											)
									}
								}
								sql.push([{
									field,
									value,
									op
								}])
							}
						})
						sql.push(s)
					} else {
						var li = where
						// 单一查询条件直接放在第一级数组中
						var l = li.trim()
						if (l.startsWith('(') && l.endsWith(')')) l = l
							.replace(/^\(/, '')
							.replace(
								/\)$/, '')
						var sep = ''
						for (var i = 0; i < seps.length; i++) {
							if (l.toLowerCase().includes(seps[i])) {
								sep = seps[i]
								break
							}
						}
						if (sep) {
							var values = l.split(new RegExp(sep, 'i'))
							var field = values[0]?.trim().replace(/^\[/,
								'').replace(/\]$/, '')
							var value = ''
							var op = sep.trim()

							if ([' in', ' not in'].includes(sep) && values[
									1]?.toLowerCase()
								.includes('select ') &&
								values[1]?.toLowerCase().includes(' from ')
							) {
								value = l.replace(field, '').replace(
										/^\s*(in|not in)\s*/i, '')
									.trim()
								if (value.startsWith('(') && value
									.endsWith(')')) value = value
									.replace(/^\(/, '')
									.replace(/\)$/, '').trim()
							} else {
								value = values[1]?.trim().replace(/^\'/,
									'').replace(/\'$/, '')

								if (['in', 'not in'].includes(op)) {
									value = value.replace(/^\(/, '')
										.replace(/\)$/, '')
									value = value.split(',').map(v => v
										.trim().replace(/^\'/,
											'')
										.replace(/\'$/,
											''))
								}
							}
							sql.push([{
								field,
								value,
								op
							}])
						}
					}
				})

				if (sql.length > 0)
					return Base64.encode(JSON.stringify({
						model: 1,
						condition: sql
					}))
				else
					return ''
			},
			translate(t) {
				if (typeof this.$t == "function") return this.$t(`page.${t}`)
				else return t;
			},
			translateSys(t) {
				if (typeof this.$t == "function") return this.$t(`sys.${t}`)
				else return t;
			},

		},
	};
</script>
<style lang="scss">
	.uni-page-modal-3200 {
		display: flex;
		flex-direction: column;
		height: calc(100vh - 30rpx);
		padding: 15rpx 0;

		.v-headStyle {
			width: 98%;
		}

		.v-content {
			flex: 1;
			display: flex;
			width: 100%;
			flex-direction: column;
			min-height: 100px;
			overflow: hidden;
			/* border:0.1px solid red; */
		}

		.view-content {
			width: 100%;
			display: flex;
			margin-top: 10rpx;
			flex-direction: column;

		}

		.dv-panel-bkcolor {
			background-color: #efefef;
		}

		.dv-panel {
			background-color: #efefef;
			padding: 20rpx 20rpx 20rpx 0px;
			border-radius: 12rpx;
			margin-bottom: 20rpx;
			text-align: right;
		}

		.dv-listHtml-Panel,
		.dv-panel-input {
			vertical-align: middle;
			width: 91%;
			display: inline-block;
			text-align: left;

			.uni-forms-item {
				padding-bottom: 5rpx;
				margin-bottom: 0;

				.uni-forms-item__label {
					height: 20px !important;
					padding: 0 10rpx 0 0 !important;
				}
			}
		}

		.dv-panel-buticon {
			line-height: 0rpx;
			text-align: left;
			/* font-size: 17px; */
			padding: 0 30rpx;
		}

		.dv-panel-buticon .btn-padding {
			padding: 10rpx 20rpx;
			display: inline-block;
			vertical-align: middle;
		}


		.dv-panel-buticon a i {
			font-size: 38rpx;
		}

		.dv-panel-buticon button {
			min-width: 120rpx;
			font-size: 32rpx;
			padding: 20rpx 20rpx 0rpx 20rpx;
			line-height: 1;
			background: #4D6AF4;
			border: none;
			color: #fff;
			font-weight: bold;
			border-radius: 8rpx;
		}


		.dv-panel-button {
			display: inline-block;
		}

		.dv-panel-button checkbox-group {
			display: inline-block;
		}

		.dv-panel-button uni-checkbox .uni-checkbox-input {
			width: 34rpx;
			height: 34rpx;
		}

		.dv-panel-button a i {
			font-size: 36rpx;
		}

		.dv-panel-button button {
			height: 50rpx;
			font-size: 26rpx;
			padding: 0 24rpx;
		}

		.view-floor {
			width: calc(100% - 20rpx);
			padding: 10rpx;
			/* border:1px solid red; */
		}

		button.btn_refresh {
			width: 49.5%;
			margin-top: 25rpx;
			padding: 20rpx;
			line-height: 1.5;
			background: #27A6E1;
			border: none;
			color: #fff;
			font-size: 38rpx;
			font-weight: bold;
			float: left;
			display: inline-block;
		}

		button.btn_cancel {
			width: 49.5%;
			margin-top: 25rpx;
			padding: 20rpx;
			line-height: 1.5;
			background: #fff;
			// border: none;
			color: #000;
			font-size: 38rpx;
			font-weight: bold;
			float: left;
			display: inline-block;
			margin-right: 20rpx;
		}

		button.btn_disabled {
			background-color: #ddd;
			color: #888;
		}

		.bk-active {
			background-color: #D6FCB2;
		}

		.uni-padding-wrap {
			margin-top: 20rpx;
			background-color: #98DAEA;
			width: 104rpx;
			height: 80rpx;
			text-align: center;
			border-radius: 54rpx;
			padding: 24rpx 0 0 0;
			float: right;
			display: inline-block;
		}

		.uni-padding-wrap a {
			font-size: 40rpx;
		}

		#dv_select {
			display: inline-block;
			width: 66%;
			background: #FFF;
			border-radius: 0 !important;
			color: #2d8cf0;
			/* padding: 10rpx 8rpx 12rpx; */
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
			margin-top: 0rpx;
			vertical-align: 20rpx;
		}

		#dv_select .uni-select {
			border: 2rpx solid #ccc;
			border-radius: 0 !important;
			color: #2d8cf0;
		}

		#dv_select .uni-select__input-text {
			color: #2d8cf0;
		}

		.input-disabled {
			background-color: #f3f3f3 !important;
		}

		.dv_panel_condent {
			background-color: #D6FCB2;
			padding: 20rpx;
			border-radius: 12rpx;
		}

		.dv_panel_attr {
			margin-bottom: 10rpx;
		}

		.dv_panel_attr .dv_inline {
			display: inline-block;
			text-align: center;
		}

		.dv_panel_attr i {
			vertical-align: 25px;
			margin: 0 10px;
		}

		.dv_panel_attr .dv_inline p {
			background: #4D6AF4;
			color: #fff;
			padding: 10rpx 15rpx;
			line-height: 1.5;
			border-radius: 10rpx;
		}

		.v-scroll-view {
			flex: 1;
			overflow: hidden;
			width: 98%;
		}

		.scroll-y {
			width: 100%;
			height: 100%;
		}

		.scroll-view_H {
			white-space: nowrap;
			width: 100%;
		}

		.dv_panel_content {
			margin: 0 10px;
		}

		.dv_panel_content .dv_panel_attr {
			margin-bottom: 5px;
		}

		.dv_panel_content .dv_panel_attr i {
			vertical-align: super;
			margin: 0 10px;
		}

		.dv_panel_content .dv_panel_attr .circel_node {}

		/* 是菱形的 */
		.dv_panel_content .dv_panel_attr .dv_diamond_node p {
			width: 50px;
			height: 50px;
			background-color: #4D6AF4;
			transform: rotate(45deg);
			-ms-transform: rotate(45deg);
			-moz-transform: rotate(45deg);
			-webkit-transform: rotate(45deg);
			-o-transform: rotate(45deg);
			margin: 15px auto;
			padding: 9px;
			// line-height: 28px;
			text-align: center;
		}

		.dv_panel_content .dv_panel_attr .dv_diamond_node p span {
			color: #fff;
			transform: rotate(-45deg);
			display: inline-block;
			text-align: center;
			overflow: hidden;
			text-overflow: ellipsis;
			// white-space: nowrap;
		}

		/* 默认形 */
		.dv_panel_content .dv_panel_attr .dv_box_node,
		.dv_panel_content .dv_panel_attr .dv_diamond_node {
			vertical-align: middle;
			display: inline-block;
			text-align: center;
			width: 100px;
		}

		.dv_panel_content .dv_panel_attr .dv_box_node p {
			background: #4D6AF4;
			color: #fff;
			padding: 3px 7px;
			line-height: 1.5;
			border-radius: 5px;
		}

		.demo-uni-row {
			margin-bottom: 0px;
			display: block;
		}

		::v-deep .uni-row {
			margin-bottom: 0px;
		}

		.view-tabpage ::v-deep .uni-row {
			margin-bottom: 5px;
		}

		.demo-uni-col {
			height: 36px;
			border-radius: 5px;
		}

		.demo-uni-row .uni-input {
			width: calc(100% - 120px);
		}
	}
</style>